let total = localStorage.getItem('total') === null ? 0 : parseFloat(localStorage.getItem('total'));

let hidden_default = localStorage.getItem('hidden_default') === null ? {} : JSON.parse(localStorage.getItem('hidden_default'));

let savedData = localStorage.getItem('save_data') === null ? {} : JSON.parse(localStorage.getItem('save_data'))
let selected_services = localStorage.getItem('selected_services') === null ? {} : JSON.parse(localStorage.getItem('selected_services'))

let isMobile = window.matchMedia("only screen and (max-width: 760px)").matches;

let baseUrl = 'http://localhost:8000';
// window.onresize = function(){ location.reload(); }
async function fetchData(column_name, queryparam, form_id) {

    document.querySelector(`#car_${form_id}`).innerHTML = '<option value="">-Select value-</option>';
    fetch(`${baseUrl}/vehicle_make?column_name=${column_name}${queryparam}`).then((response) => response.json()).then((result) => {

        result.forEach((result_single) => {

            document.querySelector(`#car_${form_id}`).innerHTML += `<option value="${result_single[column_name]}">${result_single[column_name].toUpperCase()}</option>`
        })

    })
}



function formatMoney(num) {
    num = parseFloat(num);
    var p = num.toFixed(2).split(".");
    return '₦' + p[0].split("").reverse().reduce(function (acc, num, i, orig) {
        return num == "-" ? acc : num + (i && !(i % 3) ? "," : "") + acc;
    }, "") + "." + p[1];
}

function fetchServicesCategory() {
    if(sessionStorage.getItem('cached_category')!==null){
        preloadCategory(JSON.parse(sessionStorage.getItem('cached_category')))
        return ;
    }
    fetch(baseUrl+'/services').then((response) => response.json()).then((result) => {
        preloadCategory(result)
        sessionStorage.setItem('cached_category',JSON.stringify(result));
    });

}


function preloadCategory(result){
    let i = 0;

    let isMobile = window.matchMedia("only screen and (max-width: 760px)").matches;


    result.forEach((result_single) => {

        //mobile
        if (isMobile) {
            //Conditional script here
            document.querySelector('.mobile').innerHTML += `<div class="card">
                                                                    <div class="card-header" id="headingOne">
                                                                        <h5 class="mb-0" data-toggle="collapse" data-target="#collapseOne${result_single.id}" >
                                                                            <button class="btn btn-link" style="text-decoration: none" aria-expanded="true" aria-controls="collapseOne">
                                                                               <span style="text-align: justify-all"> ${result_single.name.split('-')[0]} <br> ${result_single.name.split('-')[1]!==undefined ? result_single.name.split('-')[1] : '' }</span>  
                                                                         
                                                                            </button>
                                                                           
                                                                                     <span style="float: right; margin-top: 8px"> <i class="fal fa fa-chevron-circle-down"></i></span>
                                                                        </h5>
                                                                        
                                                                    </div>
                                    
                                                                    <div id="collapseOne${result_single.id}" class="collapse " aria-labelledby="headingOne" data-parent=".mobile">
                                                                        <div class="card-body">
                                                                           <table class="table table-striped dataTable"><thead> <th>${result_single.name}</th><th></th></thead><tbody  id="inner${result_single.id}"></tbody></table>
                                                                    </div>
                                                                </div>
                                                            </div><br>`


        }
        else{

            document.querySelector('#service_category').innerHTML += `<a style="color:black; font-weight: bold" class="nav-link ${i == 0 ? 'active' : ''}" id="v-pills-${result_single.name}" data-toggle="pill" href="#${result_single.id}" role="tab" aria-controls="v-pills-home" aria-selected="true">${result_single.name.toUpperCase()}</a>`
            document.querySelector('#service_category_content').innerHTML += `<div class="tab-pane fade nav-link ${i == 0 ? 'show active' : ''}" id="${result_single.id}" role="tabpanel" aria-labelledby="v-pills-${result_single.name}"> <table class="table table-striped dataTable"><thead> <th>${result_single.name}</th><th></th></thead><tbody  id="inner${result_single.id}"></tbody></table></div>`
        }
        result_single.services.forEach((result_service) => {

            document.querySelector(`#inner${result_single.id}`).innerHTML += `<tr><td>${result_service.name}</td><td><input type="hidden" id="json_id${result_service.id}" value='${JSON.stringify(result_service)}'><button data-toggle="tooltip" data-placement="top" onclick='addTocart(${result_service.id})' title="Add to Cart" class="btn btn-sm btn-danger addtocart${result_service.id}"  ><i class="fal fa fa-cart-plus"></i></button></td></tr>`

        })


        if (i == result.length - 1) {

            $('.dataTable').DataTable();
            hideSHowButtonDefault()
            setTimeout(function(){
                // document.querySelector('.quote_html').classList.remove('hidden')
                // document.querySelectorAll('.btn').forEach(function(elem){
                //     elem.style='display:block';
                // })
            },300)

        }
        i++;
    })


    if(localStorage.getItem('selected_services')!==null){
        $selected_service=JSON.parse(localStorage.getItem('selected_services'));
        for(let key in $selected_service){

            addTocart(key,1000);

        }

    }
}

// function preloadCategory(result){
//     document.querySelector('.sw-btn-next').classList.add('btn-danger')
//     let i = 0;
//
//
//     result.forEach((result_single) => {
//
//         //mobile
//         if (isMobile) {
//
//             //Conditional script here
//             document.querySelector('.mobile').innerHTML += `
//                                                         <div class="card">
//                                                                     <div class="card-header" id="headingOne${result_single.id}">
//                                                                         <h5 class="mb-0" >
//                                                                             <button class="btn btn-link " style="text-decoration: none"  data-toggle="collapse" data-target="#collapseOne${result_single.id}" aria-expanded="false" aria-controls="collapseOne${result_single.id}">
//                                                                                <span style="text-align: justify-all"> ${result_single.name.split('-')[0]} <br> ${result_single.name.split('-')[1]!==undefined ? result_single.name.split('-')[1] : '' }</span>
//
//                                                                             </button>
//
//                                                                                      <span style="float: right; margin-top: 8px"> <i class="fal fa fa-chevron-circle-down"></i></span>
//                                                                         </h5>
//
//                                                                     </div>
//
//                                                                     <div id="collapseOne${result_single.id}" class="collapse" aria-labelledby="headingOne${result_single.id}" data-parent=".mobile">
//                                                                         <div class="card-body">
//                                                                            <table class="table table-striped dataTable"><thead> <th>${result_single.name}</th><th></th></thead><tbody  id="inner${result_single.id}"></tbody></table>
//                                                                     </div>
//                                                                 </div>
//                                                             </div><br>`
//
//
//         }
//         else{
//
//             document.querySelector('#service_category').innerHTML += `<a style="color:black; font-weight: bold" class="nav-link ${i == 0 ? 'active' : ''}" id="v-pills-${result_single.name}" data-toggle="pill" href="#${result_single.id}" role="tab" aria-controls="v-pills-home" aria-selected="true">${result_single.name.toUpperCase()}</a>`
//             document.querySelector('#service_category_content').innerHTML += `<div class="tab-pane fade nav-link ${i == 0 ? 'show active' : ''}" id="${result_single.id}" role="tabpanel" aria-labelledby="v-pills-${result_single.name}"> <table class="table table-striped dataTable"><thead> <th>${result_single.name}</th><th></th></thead><tbody  id="inner${result_single.id}"></tbody></table></div>`
//         }
//         result_single.services.forEach((result_service) => {
//
//             document.querySelector(`#inner${result_single.id}`).innerHTML += `<tr><td>${result_service.name}</td><td><input type="hidden" id="json_id${result_service.id}" value='${JSON.stringify(result_service)}'><button data-toggle="tooltip" data-placement="top" onclick='addTocart(${result_service.id})' title="Add to Cart" class="btn btn-sm btn-danger addtocart${result_service.id}"  ><i class="fal fa fa-cart-plus"></i></button></td></tr>`
//
//         })
//
//
//         if (i == result.length - 1) {
//
//
//             $('.dataTable').DataTable();
//             hideSHowButtonDefault()
//             setTimeout(function(){
//                 // document.querySelector('.quote_html').classList.remove('hidden')
//                 // document.querySelectorAll('.btn').forEach(function(elem){
//                 //     elem.style='display:block';
//                 // })
//             },300)
//
//         }
//         i++;
//     })
// }

function addTocart(id,delay=10) {

    hidden_default[`addtocart${id}`] = 'hidden';
    localStorage.setItem('hidden_default', JSON.stringify(hidden_default))

    try{
        // alert(`addtocart${id}`)
        document.querySelector(`.addtocart${id}`).classList.add('hidden');
    }
    catch (e) {
        console.log(e)
    }

    // setTimeout(()=>{
    appendToMain(id).then((serviceDetail) => {
        appendOther(serviceDetail).then((serviceDetail) => {
            appendFreeService(serviceDetail)
        })
    })
    // },delay)




    selected_services[id] = id;
    localStorage.setItem('selected_services', JSON.stringify(selected_services))
    saveFilledData('addDeleteService');
    // sessionStorage.setItem('raw_html', document.querySelector('.quote_html').innerHTML);
}

function deleteDom(classname, id, price) {
    hidden_default[`addtocart${id}`] = 'show';
    localStorage.setItem('hidden_default', JSON.stringify(hidden_default))
    document.querySelector(`.addtocart${id}`).classList.remove('hidden');
    document.querySelectorAll(`.${classname}`).forEach((elem) => {
        elem.remove();
    })
    total -= parseFloat(price);
    delete selected_services[id];
    localStorage.setItem('selected_services', JSON.stringify(selected_services))
    // document.querySelector(`#total_amount`).innerHTML = formatMoney(total);
    saveFilledData('addDeleteService');
    // sessionStorage.setItem('raw_html', document.querySelector('.quote_html').innerHTML);
}

// async function appendToMain(id) {
//
//     // if(id.includes('o')){
//     //     return;
//     // }
//     try{
//         serviceDetail = (JSON.parse($(`#json_id${id}`).val()));
//
//
//         total += parseFloat(serviceDetail.price);
//         document.querySelector(`#services_added`).innerHTML += `  <tr class="y${serviceDetail.name.replace(/[^A-Z0-9]/ig, '').replace(',', '').replace(/[0-9]/g, '') + serviceDetail.id}">
//                                                                             <td>${serviceDetail.name}</td>
//
//                                                                             <td>
//                                                                                 <button class="btn btn-sm btn-danger" onclick="deleteDom('y${serviceDetail.name.replace(/[^A-Z0-9]/ig, '').replace(',', '').replace(/[0-9]/g, '') + serviceDetail.id}','${id}','${serviceDetail.price}')"><i class="fal fa fa-trash"></i></button>
//                                                                             </td>
//                                                                          </tr>
//                                                                         ${serviceDetail.optional_services_list.length == 0 ? '' : `
//                                                                         <tr class="y${serviceDetail.name.replace(/[^A-Z0-9]/ig, '').replace(',', '').replace(/[0-9]/g, '') + serviceDetail.id}" id="optional_services${serviceDetail.name.replace(/[^A-Z0-9]/ig, '') + serviceDetail.id}">
//                                                                             <td colspan="3"><h5 style="font-size: 13px">OPTIONAL SERVICE</h5></td>
//                                                                         </tr> `}
//                                                                                 ${serviceDetail.free_services_list.length == 0 ? '' : `
//                                                                        <tr class="y${serviceDetail.name.replace(/[^A-Z0-9]/ig, '').replace(',', '').replace(/[0-9]/g, '') + serviceDetail.id}" id="free_services${serviceDetail.name.replace(/[^A-Z0-9]/ig, '') + serviceDetail.id}">
//                                                                           <td colspan="3"><h5 style="font-size: 13px">INCLUDES</h5></td>
//
//                                                                         </tr>`}
//                                                                        `
//         return serviceDetail;
//     }
//     catch(e){  }
//
// }

async function appendToMain(id) {

    // if(id.includes('o')){
    //     return;
    // }
    try{
        serviceDetail = (JSON.parse($(`#json_id${id}`).val()));


        total += parseFloat(serviceDetail.price);
        document.querySelector(`#services_added`).innerHTML += `  <tr class="y${serviceDetail.name.replace(/[^A-Z0-9]/ig, '').replace(',', '').replace(/[0-9]/g, '') + serviceDetail.id}">
                                                                            <td>${serviceDetail.name}</td>
                                                                                 
                                                                            <td>
                                                                                <button class="btn btn-sm btn-danger" onclick="deleteDom('y${serviceDetail.name.replace(/[^A-Z0-9]/ig, '').replace(',', '').replace(/[0-9]/g, '') + serviceDetail.id}','${id}','${serviceDetail.price}')"><i class="fal fa fa-trash"></i></button>
                                                                            </td>
                                                                         </tr>
                                                                        ${serviceDetail.optional_services_list.length == 0 ? '' : `
                                                                        <tr class="y${serviceDetail.name.replace(/[^A-Z0-9]/ig, '').replace(',', '').replace(/[0-9]/g, '') + serviceDetail.id}" id="optional_services${serviceDetail.name.replace(/[^A-Z0-9]/ig, '') + serviceDetail.id}">
                                                                            <td colspan="3"><h5 style="font-size: 13px">OPTIONAL SERVICE</h5></td>
                                                                        </tr> `}
                                                                                ${serviceDetail.free_services_list.length == 0 ? '' : `
                                                                       <tr class="y${serviceDetail.name.replace(/[^A-Z0-9]/ig, '').replace(',', '').replace(/[0-9]/g, '') + serviceDetail.id}" id="free_services${serviceDetail.name.replace(/[^A-Z0-9]/ig, '') + serviceDetail.id}">
                                                                          <td colspan="3"><h5 style="font-size: 13px">INCLUDES</h5></td>

                                                                        </tr>`}
                                                                       `
        return serviceDetail;
    }
    catch(e){  }

}

function checkExist(id,value){
    for(let key in value){
        if(key==id){

            return true;
        }
    }
    return false;
}

async function appendOther(serviceDetail) {

    try {
        let i = 0;
        $selected_service = JSON.parse(localStorage.getItem('selected_services'));

        serviceDetail.optional_services_list.forEach((data_elem) => {
            // $('.bootstraptoggle').bootstrapToggle('destroy')
            if(checkExist('o' + data_elem.id, $selected_service)){
                total += parseFloat(data_elem.price)
            }

            document.querySelector(`#optional_services${serviceDetail.name.replace(/[^A-Z0-9]/ig, '') + serviceDetail.id}`).outerHTML += `
                                                                                                                                              <tr class="y${serviceDetail.name.replace(/[^A-Z0-9]/ig, '').replace(',', '').replace(/[0-9]/g, '') + serviceDetail.id}">
                                                                                                                                                <td><input type="checkbox" ${checkExist('o' + data_elem.id, $selected_service) ? 'checked' : ''} class="bootstraptoggle" id='bootstraptoggle${data_elem.price}${data_elem.id}' onchange="addOptionalServices('${data_elem.id}','${data_elem.price}')" data-toggle="toggle" data-onstyle="danger" data-offstyle="success" data-on="<i class='fa fa-trash'></i> Remove" data-off="<i class='fa fa-plus-square'></i> Add"></td>
                                                                                                                                                <td>${data_elem.name}</td>
                                                                                                                                              
                                                                                                                                            </tr>
                                                                                                                                            `
            // if (i === serviceDetail.optional_services_list.length - 1) {


            // }
            i++
        })

        $('.bootstraptoggle').bootstrapToggle()


        return serviceDetail;
    }catch (e) {
        console.log(e)
    }

}


function addOptionalServices(id, price) {

    if (document.querySelector(`#bootstraptoggle${price}${id}`).checked) {

        total += parseFloat(price)

        selected_services[`o${id}`] = `o${id}`;

        setCache()
        return;
    }
    // console.log(price-price);
    total -= parseFloat(price)
    delete selected_services[`o${id}`];
    delete selected_services[id];
    //  console.log(total);
    setCache()

}


function setCache() {
    localStorage.setItem('selected_services', JSON.stringify(selected_services))
    saveFilledData()
    // document.querySelector(`#total_amount`).innerHTML = formatMoney(total);

//    localStorage.setItem('total', total);
    // sessionStorage.setItem('raw_html', document.querySelector('.quote_html').innerHTML);
}

async function appendFreeService(serviceDetail) {
    try{


        serviceDetail.free_services_list.forEach((data_free) => {
            console.log('free_services' + serviceDetail.name.replace(/[^A-Z0-9]/ig, '') + serviceDetail.id)
            document.querySelector(`#free_services${serviceDetail.name.replace(/[^A-Z0-9]/ig, '') + serviceDetail.id}`).outerHTML += `<tr style="font-size: 14px" class="y${serviceDetail.name.replace(/[^A-Z0-9]/ig, '').replace(',', '').replace(/[0-9]/g, '') + serviceDetail.id}"><td ><span class="badge badge-success">FREE</span></td>
                                                                                            <td>${data_free.name}</td></tr>`
        })
//    localStorage.setItem('total', total);
//         document.querySelector(`#total_amount`).innerHTML = formatMoney(total);
        saveFilledData()
    }catch (e) {

    }
}

function populateVechileForm(vehicle_details) {
    saved_data = JSON.parse(localStorage.getItem('save_data'));
    data=vehicle_details.split('..');

    saved_data['make']=data[0].split('/')[0]
    saved_data['model']=data[0].split('/')[1]
    saved_data['trim']=data[1]
    saved_data['year']=data[2]
    saved_data['carcartegory']=data[3]
    localStorage.setItem('save_data',JSON.stringify(saved_data));
    prePopulate('no_trigger')
}


function dynamicInfoDisplay(value, type = 'vehicle') {
// alert('d')
    value = value.split('_');

    if(document.querySelector('.radio1').checked || document.querySelector('.radio3').checked){
        document.querySelector(`.pickup_location`).classList.remove('hidden');
    }else{
        document.querySelector(`.pickup_location`).classList.add('hidden');
    }
    if(value[0]==='phone_num' && (isNaN(parseInt(value[1])) || value[1].length <10)){
        return ;
    }

    if(value[0]==='email' && !isEmail(value[1])){
        return ;
    }
    if(value[0]==='email'){
        loadRegisteredVehicle(value[1]);
    }
    savedData[value[0]] = value[1]
    localStorage.setItem('save_data', JSON.stringify(savedData));
    if (type == 'null') {
        return;
    }
    // console.log(value[0])
    separator = '';
    if (type === 'vehicle') {

        separator = value[0] === 'mileage' || value[0] === 'location' ? '' : ' |';
    }

    document.querySelector(`#text_${value[0]}`).innerText = value[1].toUpperCase() + separator;
}



function prePopulate(trigger_mail=null) {
// alert('d')
    saved_data = JSON.parse(localStorage.getItem('save_data'));

    for (let key in saved_data) {
        // console.log(key)

        document.querySelectorAll(`.${key}`).forEach((element) => {

            if (key === 'make' || key === 'model' || key === 'trim') {
                console.log(key)
                element.innerHTML = `<option value="${saved_data[key]}">${saved_data[key].toUpperCase()}</option>`;
                return
            }
            element.value = saved_data[key];
        })

        if (key === 'pickupvehicle') {
            if (saved_data[key] === 'Yes' || saved_data[key]==='Service at Location') {
                if(saved_data[key]==='Service at Location'){
                    document.querySelector('.radio3').checked = true;
                }else{
                    document.querySelector('.radio1').checked = true;
                }

                document.querySelector(`.pickup_location`).classList.remove('hidden');


            } else{
                document.querySelector('.radio2').checked = true;

                document.querySelector(`.pickup_location`).classList.add('hidden');
            }

        }
        if(key==='datetime'){
            document.querySelector('#timepicker').value = saved_data[key].split('T')[1]
            document.querySelector('#datepicker').value = saved_data[key].split('T')[0]
            // document.querySelector('.datepicker').value =
        }
        if(key==='email' && trigger_mail==null){
            loadRegisteredVehicle(saved_data[key])
        }



        document.querySelectorAll(`.text_${key}`).forEach((element) => {
            element.innerText = saved_data[key].toUpperCase();
        }) // element.innerText=saved_data[key];

    }

}

function hideSHowButtonDefault() {
    try {
        hide_show = JSON.parse(localStorage.getItem('hidden_default'))

        for (var key in hide_show) {
            if (hide_show[key] === 'hidden') {
                document.querySelector(`.${key}`).classList.add('hidden')
            } else {
                document.querySelector(`.${key}`).classList.remove('hidden')
            }

        }
    }catch (e) {
        console.log(e);
    }
}




function doCapture() {
    // window.scrollTo(0, 0);
    //
    // id=isMobile ? '#mobile_movement' : '.quote_html';
    // document.querySelector(id).classList.add('fix_width','col-md-9')
    //
    //
    // // Convert the div to image (canvas)
    // html2canvas(document.querySelector(`${id}`)).then(function (canvas) {
    //     saveFilledData(`image=${canvas.toDataURL("image/jpeg", 1)}`)
    //     saveAs(canvas.toDataURL(), 'quote.png');
    // });
    // document.querySelector(id).classList.remove('fix_width','col-md-9')
    // saveAs(canvas.toDataURL(), 'quote.png');
    // alert($('#smartwizard').smartWizard("getStepIndex"))
    if($('#smartwizard').smartWizard("getStepIndex")!==4 ){
        toastr.error('Please Complete form before Generating Quote');
        return
    }
    saveFilledData('gen_quote')
    clearPersistentData();

}


function clearPersistentData(){

    localStorage.removeItem('selected_services')
    localStorage.removeItem('hidden_default')

    data=['datatime','pickupvehicle','location','appointment','selected_service']
    for(var value in data){
        // alert(value);
        delete savedData[value];
    }
    localStorage.setItem('save_data',JSON.parse(savedData));
}




function saveAs(uri, filename) {

    var link = document.createElement('a');

    if (typeof link.download === 'string') {

        link.href = uri;
        link.download = filename;

        //Firefox requires the link to be in the body
        document.body.appendChild(link);

        //simulate click
        link.click();

        //remove the link when done
        document.body.removeChild(link);

    } else {

        window.open(uri);

    }
}

// function initMaps() {

//     const input = document.querySelectorAll(".location_address").forEach((input, index) => {
//         const searchBox = new google.maps.places.SearchBox(input);

//         if (index == 1) {
//             searchBox.addListener('places_changed', function () {


//                 dynamicInfoDisplay('location_' + input.value)


//             });
//         }
//     })
// }
function loadRegisteredVehicle(email){
    $.post(`${baseUrl}/api/vehicleList?email=${email}`,function(data) {
        if(data.status==='success'){
            document.querySelector(`#carlist`).innerHTML='<option value="">-Select Registered Cars From List-</option>'
            document.querySelector(`.carList_group`).classList.remove('hidden');
            data.message.forEach((data_val)=>{
                document.querySelector(`#carlist`).innerHTML +=`<option value="${data_val.model+'..'+data_val.trim+'..'+data_val.year+'..'+data_val.car_type}">${data_val.year} -:${data_val.model}-${data_val.trim}</option>`
            })

        }
    })
}



function swapDiv(){
    elem=document.querySelector('.quote_html')
    prev_position=elem.innerHTML
    elem.classList.remove('blue_border','col-md-4')
    elem.innerHTML='';

    elem2=document.querySelector('#mobile_movement')
    elem2.innerHTML = prev_position;
    elem2.classList.add('blue_border','col-md-12')
}

function setButtonTextLast(){
    if( $('#smartwizard').smartWizard("getStepIndex")===4 ){
        document.querySelectorAll('.finish_behaviour').forEach((elem)=>{
            elem.innerText = 'Finish';
        })

    }
}
function prepopulateCustomerCategory(){
    document.querySelector('.clientcategory').innerHTML ='<option value="">-select category-</option>'
    $.get(`${baseUrl}/clientcategory`,function(data){
        data.forEach((data)=>{
            document.querySelector('.clientcategory').innerHTML +=`<option value="${data.factor}">${data.category.toUpperCase()}</option>`
        })
        document.querySelector('.clientcategory').value=savedData['clientcategory']
    })
}

window.onload =  ()=> {
    prepopulateCustomerCategory()
    prepoulateState()
    //
    $('#timepicker').datetimepicker({
        format: 'LT'
    }).on("dp.change",function() {
        dynamicInfoDisplay('datetime_'+document.querySelector('#datepicker').value+' T '+document.querySelector('#timepicker').value,'appointment')

    });
    $('#datepicker').datetimepicker({
        format: 'DD MMMM ,YYYY '
    }).on("dp.change",function() {
        dynamicInfoDisplay('datetime_'+document.querySelector('#datepicker').value+' T '+document.querySelector('#timepicker').value,'appointment')

    });

    document.querySelector(`.pickup_location`).classList.add('hidden');
    $('#loading').hide()


    if(isMobile){
        document.querySelector('.hidden-sm').style='display:none'
        swapDiv()
    }
    $('#smartwizard').smartWizard({
        theme: 'arrows',

        anchorSettings: {
            anchorClickable: true
        },
        toolbarSettings: {
            toolbarPosition: 'both', // none, top, bottom, both
            toolbarButtonPosition: 'right', // left, right, center
            toolbarExtraButtons: [
                $('<button></button>').text('Quote')
                    .addClass('btn btn-danger red_color finish_behaviour')
                    .on('click', function(){



                        if(submitStep(0)===false || submitStep(1)===false ||  appointMentDate()===false){
                            return;
                        }
                        if( $('#smartwizard').smartWizard("getStepIndex")===4 ){
                            window.parent.location='https://autocitienterprise.com';
                            return;
                        }

                        $('#smartwizard').smartWizard('goToStep', 4)
                        document.querySelectorAll('.finish_behaviour').forEach((elem)=>{
                            elem.innerText = 'Finish';
                        })
                    })
            ]
        }
    }).on("leaveStep", function (e, anchorObject, currentStepIndex, nextStepIndex, stepDirection) {
        // $('#smartwizard').smartWizard();

        document.querySelectorAll('.finish_behaviour').forEach((elem)=>{
            elem.innerText = 'Quote';

        })


        if( currentStepIndex===3 && nextStepIndex===4) {

            document.querySelectorAll('.finish_behaviour').forEach((elem)=>{
                elem.innerText = 'Finish';

            })
        }

        saveFilledData();
        if (currentStepIndex === 0) {
            return submitStep(0);
        }
        if (currentStepIndex === 1) {
            return submitStep(1);
        }

        if (currentStepIndex === 3) {
            return appointMentDate();
        }





        // return  false;
        // return confirm("Do you want to leave the step " + currentStepIndex + "?");
    });

    if(getParameterByName('payment_status')==='success'){

        $('#smartwizard').smartWizard('goToStep', 4)
        document.querySelector('#makePayment').classList.add('hidden');
        document.querySelector('#paymentSuccess').innerHTML=`Payment Successfull , Click <a href="${baseUrl}/jobcard/generateInvoice?id=${getParameterByName('jobcard_id')}" onclick="clearPersistentData()">Here</a> to download your Invoice, If you don'nt know your password , please check your email for your login details`

        alert('Payment Successful');
    }
    setButtonTextLast()



    // sessionStorage.setItem('raw_html',document.querySelector('.quote_html').innerHTML);
    // if (sessionStorage.getItem('raw_html') !== null) {
    //     document.querySelector('.quote_html').innerHTML = sessionStorage.getItem('raw_html');
    //
    //     $('.bootstraptoggle').bootstrapToggle();
    // }

    $('[data-toggle="tooltip"]').tooltip()
    fetchServicesCategory()
    var d = new Date();
    var year = d.getFullYear();
    document.querySelector(`#year`).innerHTML = '<option value="">-Select a year-</option>';
    for (let i = 1990; i <= year; i++) {
        document.querySelector(`#year`).innerHTML += `<option value="${i}">${i}</option>`
    }

    enableChangeEvent()

    prePopulate()
    fetchData('model_make_id', '', 'make')

}

function enableChangeEvent() {
    $('#car_make').change(function () {
        year = document.querySelector('#year').value;
        fetchData('model_name', '&model_year=' + year + '&model_make_id=' + $(this).val(), 'model');
    })

    $('#car_model').change(function () {
        year = document.querySelector('#year').value;
        fetchData('model_trim', '&model_year=' + year + '&model_make_id=' + $('#car_make').val(), 'trim');
    })
}
function saveFilledData(quoteImage='') {
    savedData['selected_service'] = selected_services;
    if(quoteImage==='makepayment'){
        savedData['action']='makePayment'
    }

    $.get(`${baseUrl}/api/saveCustomerSelectedService`, savedData, function (data) {


              if(quoteImage==='gen_quote'){
            // window.location=
            window.parent.location=`https://api.html2pdf.app/v1/generate?url=${baseUrl}/api/customer/viewQuote?id=${data.id}&apiKey=5c2be1ebab316982de1eb285edc17c0f0ed5d0f639714fdb760d3c388767c6d6&marginLeft=50&marginTop=10`
        }
        if(quoteImage==='appointment'){
            saveFileUpload(data.id);
        }
        if(quoteImage==='makepayment'){
            if(data.status=='success'){
                if(!data.authorization_url){
                    document.querySelector('#makePayment').classList.add('hidden');
                    return toastr.success(data.message)
                }
                window.location=data.authorization_url;
                return;

            }
            return toastr.error(data.message)
        }
        document.querySelector(`#total_amount`).innerHTML = data.auto_cost==undefined ? '<i style="color:red; font-size:15px; font-weight:bold">COMPLETE FORM TO REVEAL QUOTE</i>' : formatMoney(data.auto_cost)

    })


}

function isEmail(email) {
    return /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))$/i.test(email);
}
function submitStep(step) {


    if(step===0){
        names = $('#name').val()
        phone_num = $('#phonenum').val()
        email = $('#email').val()
        clientcategory = $('#clientcategory').val()

        if(names === '' || phone_num === '' || email === '' || !isEmail(email) || isNaN(parseInt(phone_num)) || phone_num.length <10 || clientcategory==''){
            toastr.error("You Have Some Invalid Input");
            return false;
        }
        return;
    }


    make = $('#make').val()
    model = $('#model').val()
    year = $('#year').val()
    mileage = $('#mileage').val()


    if ( make === '' || model === '' || year === '' || mileage === '') {

        toastr.error("Some fields blank");
        return false;
    }
    saveFilledData();

    // fetch('').then((response)=>response.json()).


}

function appointMentDate() {
    appointment_date = $('#appointment_date').val()
    appointment_time = $('#appointment_time').val()
    additonal_details = $('#additonal_details').val()

    if (appointment_date === '' || appointment_time === '' || additonal_details === '') {
        toastr.error("Some fields blank");
        return false;
    }

    saveFilledData('appointment');
}

function saveFileUpload(id) {
    const files = document.querySelector('[name=file]').files;
    const formData = new FormData();
    for (let i = 0; i < files.length; i++) {
        let file = files[i]

        formData.append('files[]', file)


    }
    formData.append('request_id', id)
    fetch(`${baseUrl}/api/saveCustomerSelectedService`, {
        method: 'POST',
        body: formData,
    }).then((response)=>response.json()).then((response) => {
        if(response.status==='success') {
            return;
        }
        toastr.error('Some Error Occurred With your Upload , Please go back to the previous step and re-upload');
        // console.log(response)
    })

}


function getParameterByName(name, url) {
    if (!url) url = window.location.href;
    name = name.replace(/[\[\]]/g, '\\$&');
    var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, ' '));
}

function prepoulateState(){
    element=document.querySelector('.state');
    element.innerHTML='<option value="">-Select State-</option>'
    fetch(`${baseUrl}/location?column_name=state`).then((response)=>response.json()).then((response)=>{
        // console.log(response)

        response.forEach((data_value)=>{
            element.innerHTML+=`<option value="${data_value.state}">${data_value.state}</option>`;
        })
    })
}

function populateLga(state){
    element=document.querySelector('.lga');
    element.innerHTML='<option value="">-Select Lga-</option>'
    fetch(`${baseUrl}/location?column_name=area&state=${state}`).then((response)=>response.json()).then((response)=>{

        response.forEach((data_value)=>{
            element.innerHTML+=`<option value="${data_value.id}">${data_value.area}</option>`;
        })
    })
}




